=== lib/Optimizer/Transforms/CMakeLists.txt ===
add_flang_library(FIRTransforms
  AbstractResult.cpp
  AddAliasTags.cpp
  AffinePromotion.cpp
  AffineDemotion.cpp
  AnnotateConstant.cpp
  AssumedRankOpConversion.cpp
  CharacterConversion.cpp
  CompilerGeneratedNames.cpp
  ConstantArgumentGlobalisation.cpp
  ControlFlowConverter.cpp
  CUFAddConstructor.cpp
  CUFDeviceGlobal.cpp
  CUFOpConversion.cpp
  CUFGPUToLLVMConversion.cpp
  ArrayValueCopy.cpp
  ExternalNameConversion.cpp
  MemoryUtils.cpp
  MemoryAllocation.cpp
  StackArrays.cpp
  MemRefDataFlowOpt.cpp
  SimplifyRegionLite.cpp
  AlgebraicSimplification.cpp
  SimplifyIntrinsics.cpp
  AddDebugInfo.cpp
  PolymorphicOpConversion.cpp
  LoopVersioning.cpp
  StackReclaim.cpp
  VScaleAttr.cpp
  FunctionAttr.cpp
  DebugTypeGenerator.cpp

  DEPENDS
  CUFAttrs
  CUFDialect
  FIRDialect
  FIROptTransformsPassIncGen
  HLFIROpsIncGen

  LINK_LIBS
  CUFAttrs
  CUFDialect
  FIRAnalysis
  FIRBuilder
  FIRCodeGen
  FIRDialect
  FIRDialectSupport
  FIRSupport
  FortranCommon
  HLFIRDialect

  MLIR_LIBS
  MLIRAffineUtils
  MLIRFuncDialect
  MLIRGPUDialect
  MLIRLLVMDialect
  MLIRLLVMCommonConversion
  MLIRMathTransforms
  MLIROpenACCDialect
  MLIROpenACCToLLVMIRTranslation
  MLIROpenMPDialect
)
